#line 1 "D:/Mikrokontroleri/663_visual_c_.net_easy_usb_component_for_all_kits_mikroe_development.__v1.0.0.0/Examples USBHIDnetClass.org/mikroC PRO for ARM/EasyMX PRO for ARM v7 for STM32/USB/HID_Read_Write_Interrupt/HID_Read_Write.c"
#line 25 "D:/Mikrokontroleri/663_visual_c_.net_easy_usb_component_for_all_kits_mikroe_development.__v1.0.0.0/Examples USBHIDnetClass.org/mikroC PRO for ARM/EasyMX PRO for ARM v7 for STM32/USB/HID_Read_Write_Interrupt/HID_Read_Write.c"
char readbuff[64];
char writebuff[64];
unsigned int ADC_VALUE;
unsigned int DS1820_VALUE;
unsigned int LM35_VALUE;

void USB0Interrupt() iv IVT_INT_OTG_FS{
 USB_Interrupt_Proc();
}



unsigned int ReadDS1820(){
 unsigned int temp;

 Ow_Reset(&GPIOA_BASE, 3);
 Ow_Write(&GPIOA_BASE, 3, 0xCC);
 Ow_Write(&GPIOA_BASE, 3, 0x44);
 Delay_ms(750);

 Ow_Reset(&GPIOA_BASE, 3);
 Ow_Write(&GPIOA_BASE, 3, 0xCC);
 Ow_Write(&GPIOA_BASE, 3, 0xBE);

 temp = Ow_Read(&GPIOA_BASE, 3);
 temp = (Ow_Read(&GPIOA_BASE, 3) << 8) + temp;
 return temp;
}


void main(void){

 ADC_Set_Input_Channel(_ADC_CHANNEL_4 | _ADC_CHANNEL_10);

 HID_Enable(&readbuff,&writebuff);

 while(1){
 while(!HID_Read())
 ;

 DS1820_VALUE = ReadDS1820();

 writebuff[0]=(char)((DS1820_VALUE >> 8) & 0xFF);
 writebuff[1]=(char)(DS1820_VALUE & 0xFF);


 LM35_VALUE = ADC1_Read(10);
 delay_ms(10);

 writebuff[2]=(char)((LM35_VALUE >> 8) & 0xFF);
 writebuff[3]=(char)(LM35_VALUE & 0xFF);


 ADC_VALUE = ADC1_Read(4);
 delay_ms(10);

 writebuff[4]=(char)((ADC_VALUE >> 8) & 0xFF);
 writebuff[5]=(char)(ADC_VALUE & 0xFF);

 while(!HID_Write(&writebuff,64))
 ;
 }
}
