_USB0Interrupt:
;HID_Read_Write.c,31 :: 		void USB0Interrupt() iv IVT_INT_OTG_FS{
SUB	SP, SP, #4
STR	LR, [SP, #0]
;HID_Read_Write.c,32 :: 		USB_Interrupt_Proc();
BL	_USB_Interrupt_Proc+0
;HID_Read_Write.c,33 :: 		}
L_end_USB0Interrupt:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _USB0Interrupt
_ReadDS1820:
;HID_Read_Write.c,37 :: 		unsigned int ReadDS1820(){
SUB	SP, SP, #8
STR	LR, [SP, #0]
;HID_Read_Write.c,40 :: 		Ow_Reset(&GPIOA_BASE, 3);                         // Onewire reset signal
MOVS	R1, #3
MOVW	R0, #lo_addr(GPIOA_BASE+0)
MOVT	R0, #hi_addr(GPIOA_BASE+0)
BL	_Ow_Reset+0
;HID_Read_Write.c,41 :: 		Ow_Write(&GPIOA_BASE, 3, 0xCC);                   // Issue command SKIP_ROM
MOVS	R2, #204
MOVS	R1, #3
MOVW	R0, #lo_addr(GPIOA_BASE+0)
MOVT	R0, #hi_addr(GPIOA_BASE+0)
BL	_Ow_Write+0
;HID_Read_Write.c,42 :: 		Ow_Write(&GPIOA_BASE, 3, 0x44);                   // Issue command CONVERT_T
MOVS	R2, #68
MOVS	R1, #3
MOVW	R0, #lo_addr(GPIOA_BASE+0)
MOVT	R0, #hi_addr(GPIOA_BASE+0)
BL	_Ow_Write+0
;HID_Read_Write.c,43 :: 		Delay_ms(750);
MOVW	R7, #21567
MOVT	R7, #137
NOP
NOP
L_ReadDS18200:
SUBS	R7, R7, #1
BNE	L_ReadDS18200
NOP
NOP
NOP
;HID_Read_Write.c,45 :: 		Ow_Reset(&GPIOA_BASE, 3);
MOVS	R1, #3
MOVW	R0, #lo_addr(GPIOA_BASE+0)
MOVT	R0, #hi_addr(GPIOA_BASE+0)
BL	_Ow_Reset+0
;HID_Read_Write.c,46 :: 		Ow_Write(&GPIOA_BASE, 3, 0xCC);                   // Issue command SKIP_ROM
MOVS	R2, #204
MOVS	R1, #3
MOVW	R0, #lo_addr(GPIOA_BASE+0)
MOVT	R0, #hi_addr(GPIOA_BASE+0)
BL	_Ow_Write+0
;HID_Read_Write.c,47 :: 		Ow_Write(&GPIOA_BASE, 3, 0xBE);                   // Issue command READ_SCRATCHPAD
MOVS	R2, #190
MOVS	R1, #3
MOVW	R0, #lo_addr(GPIOA_BASE+0)
MOVT	R0, #hi_addr(GPIOA_BASE+0)
BL	_Ow_Write+0
;HID_Read_Write.c,49 :: 		temp =  Ow_Read(&GPIOA_BASE, 3);
MOVS	R1, #3
MOVW	R0, #lo_addr(GPIOA_BASE+0)
MOVT	R0, #hi_addr(GPIOA_BASE+0)
BL	_Ow_Read+0
; temp start address is: 4 (R1)
UXTB	R1, R0
;HID_Read_Write.c,50 :: 		temp = (Ow_Read(&GPIOA_BASE, 3) << 8) + temp;
STRH	R1, [SP, #4]
MOVS	R1, #3
MOVW	R0, #lo_addr(GPIOA_BASE+0)
MOVT	R0, #hi_addr(GPIOA_BASE+0)
BL	_Ow_Read+0
LDRH	R1, [SP, #4]
LSLS	R0, R0, #8
UXTH	R0, R0
ADDS	R0, R0, R1
; temp end address is: 4 (R1)
;HID_Read_Write.c,51 :: 		return temp;
;HID_Read_Write.c,52 :: 		}
L_end_ReadDS1820:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of _ReadDS1820
_main:
;HID_Read_Write.c,55 :: 		void main(void){
;HID_Read_Write.c,57 :: 		ADC_Set_Input_Channel(_ADC_CHANNEL_4 | _ADC_CHANNEL_10);
MOVW	R0, #1040
BL	_ADC_Set_Input_Channel+0
;HID_Read_Write.c,59 :: 		HID_Enable(&readbuff,&writebuff);
MOVW	R1, #lo_addr(_writebuff+0)
MOVT	R1, #hi_addr(_writebuff+0)
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
BL	_HID_Enable+0
;HID_Read_Write.c,61 :: 		while(1){
L_main2:
;HID_Read_Write.c,62 :: 		while(!HID_Read())
L_main4:
BL	_HID_Read+0
CMP	R0, #0
IT	NE
BNE	L_main5
;HID_Read_Write.c,63 :: 		;
IT	AL
BAL	L_main4
L_main5:
;HID_Read_Write.c,65 :: 		DS1820_VALUE = ReadDS1820();
BL	_ReadDS1820+0
MOVW	R1, #lo_addr(_DS1820_VALUE+0)
MOVT	R1, #hi_addr(_DS1820_VALUE+0)
STRH	R0, [R1, #0]
;HID_Read_Write.c,67 :: 		writebuff[0]=(char)((DS1820_VALUE >> 8) & 0xFF);
LSRS	R1, R0, #8
UXTH	R1, R1
AND	R1, R1, #255
UXTB	R2, R1
MOVW	R1, #lo_addr(_writebuff+0)
MOVT	R1, #hi_addr(_writebuff+0)
STRB	R2, [R1, #0]
;HID_Read_Write.c,68 :: 		writebuff[1]=(char)(DS1820_VALUE & 0xFF);
AND	R0, R0, #255
UXTB	R1, R0
MOVW	R0, #lo_addr(_writebuff+1)
MOVT	R0, #hi_addr(_writebuff+1)
STRB	R1, [R0, #0]
;HID_Read_Write.c,71 :: 		LM35_VALUE = ADC1_Read(10);
MOVS	R0, #10
BL	_ADC1_Read+0
MOVW	R2, #lo_addr(_LM35_VALUE+0)
MOVT	R2, #hi_addr(_LM35_VALUE+0)
STRH	R0, [R2, #0]
;HID_Read_Write.c,72 :: 		delay_ms(10);
MOVW	R7, #54463
MOVT	R7, #1
NOP
NOP
L_main6:
SUBS	R7, R7, #1
BNE	L_main6
NOP
NOP
NOP
;HID_Read_Write.c,74 :: 		writebuff[2]=(char)((LM35_VALUE >> 8) & 0xFF);
MOVW	R0, #lo_addr(_LM35_VALUE+0)
MOVT	R0, #hi_addr(_LM35_VALUE+0)
LDRH	R0, [R0, #0]
LSRS	R0, R0, #8
UXTH	R0, R0
AND	R0, R0, #255
UXTB	R1, R0
MOVW	R0, #lo_addr(_writebuff+2)
MOVT	R0, #hi_addr(_writebuff+2)
STRB	R1, [R0, #0]
;HID_Read_Write.c,75 :: 		writebuff[3]=(char)(LM35_VALUE & 0xFF);
MOV	R0, R2
LDRH	R0, [R0, #0]
AND	R0, R0, #255
UXTB	R1, R0
MOVW	R0, #lo_addr(_writebuff+3)
MOVT	R0, #hi_addr(_writebuff+3)
STRB	R1, [R0, #0]
;HID_Read_Write.c,78 :: 		ADC_VALUE = ADC1_Read(4);
MOVS	R0, #4
BL	_ADC1_Read+0
MOVW	R2, #lo_addr(_ADC_VALUE+0)
MOVT	R2, #hi_addr(_ADC_VALUE+0)
STRH	R0, [R2, #0]
;HID_Read_Write.c,79 :: 		delay_ms(10);
MOVW	R7, #54463
MOVT	R7, #1
NOP
NOP
L_main8:
SUBS	R7, R7, #1
BNE	L_main8
NOP
NOP
NOP
;HID_Read_Write.c,81 :: 		writebuff[4]=(char)((ADC_VALUE >> 8) & 0xFF);
MOVW	R0, #lo_addr(_ADC_VALUE+0)
MOVT	R0, #hi_addr(_ADC_VALUE+0)
LDRH	R0, [R0, #0]
LSRS	R0, R0, #8
UXTH	R0, R0
AND	R0, R0, #255
UXTB	R1, R0
MOVW	R0, #lo_addr(_writebuff+4)
MOVT	R0, #hi_addr(_writebuff+4)
STRB	R1, [R0, #0]
;HID_Read_Write.c,82 :: 		writebuff[5]=(char)(ADC_VALUE & 0xFF);
MOV	R0, R2
LDRH	R0, [R0, #0]
AND	R0, R0, #255
UXTB	R1, R0
MOVW	R0, #lo_addr(_writebuff+5)
MOVT	R0, #hi_addr(_writebuff+5)
STRB	R1, [R0, #0]
;HID_Read_Write.c,84 :: 		while(!HID_Write(&writebuff,64))
L_main10:
MOVS	R1, #64
MOVW	R0, #lo_addr(_writebuff+0)
MOVT	R0, #hi_addr(_writebuff+0)
BL	_HID_Write+0
CMP	R0, #0
IT	NE
BNE	L_main11
;HID_Read_Write.c,85 :: 		;
IT	AL
BAL	L_main10
L_main11:
;HID_Read_Write.c,86 :: 		}
IT	AL
BAL	L_main2
;HID_Read_Write.c,87 :: 		}
L_end_main:
L__main_end_loop:
B	L__main_end_loop
; end of _main
